void draw()
{
  // refresh the canvas everyframe
  background(104);
  //modifying the cell size according to window size

  translate( -width/2, -height/4);   // Peasycam intially sets lookAt() at (0,0,0) hence we need to transalte the axis
   
  if (controlP5.window(this).isMouseOver()) 
         {
          cam.setActive(false);
          } 
        else 
        {
          cam.setActive(true);
        }
        

  
  // create base lines  
  //fill(255, 192);sphere
  
  // creating grid lines in 3D
  
  if ( lineFlag)
      {
      stroke(255);
      for ( int i =0 ; i <= blockWidth * (numRows) ; i+= blockWidth)
          {
           pushMatrix();                                                  //setting up a matrix to keep the current graphi coordinates
           translate(constantMarginOnRows, constantMarginOnColumns);      //translate to the correct position
           line( i,0,0,i, blockHeight * (numColumns-1)  ,0);              //creating a line (x,y,z)
           popMatrix();                                                   // going back to previos projection matrix   
          }           
      for ( int i = 0 ; i < blockHeight* numColumns ; i+= blockHeight)
          {
           pushMatrix();
           translate(constantMarginOnRows, constantMarginOnColumns); 
           line ( 0,i,0,blockWidth* numRows ,i,0);
           popMatrix();
          }
      }
   
  
  //displaying the cells                        
  for ( int  i = 0 ; i< numRows ; i++)
      {
       
        
        for ( int  j= 0 ; j< numColumns-1 ; j++)
            {
         
              if( dataMatrix[i][j] > minimumNumber)
//              if( dataMatrix[i][j]!=0)
                {
                  noStroke();
                  fill (28,200,dataMatrix[i][j]*800/ maxCount , 192 );                    // setting up a color for the box
                  pushMatrix();                                                          // doing the same for all the boxes, sadly that is the only way to do this
                  translate(constantMarginOnRows, constantMarginOnColumns);              // translating coordiantes
                  
                  int zTranslation = (dataMatrix[i][j]*255/ maxCount)* 3;
                  translate( i* blockWidth + blockWidth/2,  j* blockHeight + blockHeight/2   , zTranslation );     // translating coordiantes to box position     
                                                                                                                                            // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center
                  //box( blockWidth, blockHeight, (dataMatrix[i][j])* 3  );                                                      // creating a cube of appropriate size 
                  box( blockWidth, blockHeight, blockHeight*0.75 );//creating a cube   
//                  sphere( blockWidth/2);   
                  // floating boxes instad of bar graphs
                  
                  // drawing text over the boxes
                  if ( numberFlag)
                      {
                       // box values
                       translate( 0,0, blockHeight/2 + 2 );     // translating coordiantes to box position                      
                       textFont(myHelvetica12);
                       textAlign(CENTER,CENTER);
                       fill(0);       
                       text( dataMatrix[i][j] , 0,0  );
                   
                      }
                  
                  popMatrix();
                }
            }
      }

    //supporting text
    // nochanges required here. As this is being drawn at the base plane
    
   if ( textFlag)
     {
//     for ( int  i = 0 ; i< numColumns-1 ; i++)   // y varies
//        {
//
//        }
        
        
   
     
    
    textFont(myHelvetica20);
    textAlign(LEFT ,CENTER);
    fill(255);
    
    text( "Are Gothic Books more read during rainy months?" , constantMarginOnRows , constantMarginOnColumns/2 );
    
          textFont(myHelvetica12);
          textAlign(RIGHT,CENTER);
          fill(255);       
          text( "Mysteries of Udolpho", constantMarginOnRows-blockWidth/2,constantMarginOnColumns + blockHeight*0.25);
          text( "The Hound of Baskervilles", constantMarginOnRows-blockWidth/2,constantMarginOnColumns + blockHeight * 1.25);
          text( "Dracula", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 2.25 );
          text( "Edgar Allan Poe", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 3.25 );
          text( "Northanger Abbey", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 4.25 );
          text( "Frankenstein", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 5.25 );
          text( "Dr. Jekyll and Mr. Hyde", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 6.25 );  
          text( "Travels with Charley", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 7.25 );
          text( "Average rain days per month", constantMarginOnRows-blockWidth/2 ,constantMarginOnColumns + blockHeight * 9 );

          textFont(myHelvetica9);
         textAlign(LEFT,CENTER);
          fill(255);        
          text("18  16  17  14  10  9   5   6   9   13  18  19  18  16  17  14  10  9   5   6   9   13  18  19  18  16  17  14  10  9   5   6   9   13  18  19  18  16  17  14  10  9   5   6   9   13  18  19  18  16  17  14  10  9   5   6   9   13  18  19  18  16  17  14  10  9  5  6  9  13  18  19  18  16  17  14  10  9  5  6  9  13  18  19  18  16  17  14  10  9  5  6  9  13  18  19", constantMarginOnRows + blockWidth*0.25  , constantMarginOnColumns + blockHeight * numColumns );        
    textFont(myHelvetica17);
         textAlign(LEFT,CENTER);
          fill(232,213,28);
          text("Rain                     Rain                              Rain                              Rain                              Rain                              Rain                             Rain                            Rain                            Rain", constantMarginOnRows + blockWidth*0.25  , constantMarginOnColumns + blockHeight * numColumns+blockHeight );
          fill (232,111,28);
          text("              Drought                        Drought                          Drought                         Drought                         Drought                         Drought                       Drought                       Drought", constantMarginOnRows + blockWidth*0.25  , constantMarginOnColumns + blockHeight * numColumns+blockHeight);

      } 
        
   drawGUI();      
      
}      // end of draw

