void setup()
{
  
  size(1600,900,OPENGL);                      // setting up the size of window
  
 
  
  if (frame != null) {
     frame.setResizable(true);          // resizable window
  }
  
  //setting up the camera
  cam= new PeasyCam( this,0,0,0,1000);       
  cam.setMinimumDistance(100);        // how near the camera can get 0,0,0
  cam.setMaximumDistance(3000);       // how far the camera can travel
        
                
  //control P5 stuff      
  controlP5 = new ControlP5(this); 
  g3 = (PGraphics3D)g;     
  setupGUI();
  
        
  background(104);                     //set background to gray
  //noLoop();                            //to run draw() only once


 
 table = new Table();                 //allocating memory to new table 
  table = loadTable("gothicnovels4.csv", "header");  //loading table

  
  numRows = table.getRowCount();        //getting number of rows in the table
  numColumns = table.getColumnCount();  //getting the number of columns in table
  
  dataMatrix = new int [numRows][numColumns];  //allocating memory to the internal 2D array
  
  //copying the table data into 2D array
  for ( int  i = 0 ; i< numRows ; i++)
      {
        for ( int  j= 0 ; j< numColumns ; j++)
            {
              dataMatrix[i][j]  = table.getInt(i,j);          // j- 1 if the first column was the day number             
              println("data value: "+ dataMatrix[i][j]);              
            }
      }
      
   println("data transferred");
   
   //finding the maximum count in the data
   
   maxCount = dataMatrix[0][0];   
    for ( int  i = 0 ; i< numRows ; i++)
      {
        for ( int  j= 0 ; j< numColumns ; j++)
            {
             if(maxCount<dataMatrix[i][j])
              {
                maxCount=dataMatrix[i][j];
              }
              
            }
      }
      
   println ( "maximum value is:"+ maxCount);
   println ( "rowCount: "+ numRows);
   println ( "columnCount: "+ numColumns);
     
}  
