//adapted from Mohit Hingorani for MAT259 Winter 2015


// importing peasycam into processing, peasycam is used for manipualting the camera positions
import peasy.test.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;


// setting up PeasyCam
PeasyCam cam;


// including  ControlP5

import controlP5.*;
ControlP5 controlP5;

PMatrix3D currCameraMatrix;
PGraphics3D g3; 


// setting up fonts for text
PFont  myHelvetica9 = createFont("Helvetica",9, true);
PFont  myHelvetica12 = createFont("Helvetica",12, true);
PFont  myHelvetica17 = createFont("Helvetica",17, true);
PFont  myHelvetica20 = createFont("Helvetica",30, true);


//to store the data table
int [][] dataMatrix = null;

// to store the maximum possible value
int maxCount; 

// intialzing number or rows & columns , can be modified later
int numRows;
int numColumns;

//  text formatting variables 
float constantMarginOnRows = 160;
float constantMarginOnColumns = 100;
Table table; 
Table rainTable;
int rowCount;

float blockWidth = 15;
float blockHeight = 20;   // initial 80

int p5Margin = 30;
int p5Distance = 22;

int buttonWidth = 150;
int buttonHeight = 20;

boolean textFlag= false;
boolean numberFlag = false;
boolean lineFlag = false; 

int minimumNumber = 1;
